--Configure database to register the assembly
--1. --EXEC sp_configure <configurename>,<valuetoset>
	EXEC sp_configure 'clr enabled',1
	RECONFIGURE WITH OVERRIDE 
	GO
--2.Sys.assemblies,Sys.assembly_files,Sys.assembly_references
	--SYS.OBJECTS,SYS.ASSEMBLY_MODULES,SYS.ASSEMBLY_TYPES
	--Once deployed, the source file, pdb,library ref will get stored in assembly_files table.
	--To get the content of the actual .cs file,
	SELECT CONVERT(varchar(MAX), content)
	FROM sys.assembly_files f
	INNER JOIN sys.assemblies a
	ON f.assembly_id = a.assembly_id
	WHERE a.name = 'SQLCLRLibrary'
	AND f.name = 'HelloWorld.cs'

	Select * from sys.assemblies
	select * from sys.assembly_files where assembly_id='65539'
--3. Function to retrieve the Framework version
CREATE FUNCTION dbo.GetCLRFrameworkMajorVersion()
RETURNS int
AS
EXTERNAL NAME
SQLCLRLibrary.StoredProcedures.GetCLRFrameworkMajorVersion
--<AssemblyName>.<classname>.<methodname>
--alter assembly SQLCLRLibrary drop file ALL
--SELECT SqlCLRVersion=mfnGetCLRFrameworkMajorVersion()
	
--delete from sys.objects where name like 'GetCLRFrameworkMajorVersion%'
	
	--select dbo.GetCLRFrameworkMajorVersion()
	--drop function dbo.GetCLRFrameworkMajorVersion
-- Loaded Assemblies (run in each database)
SELECT sa.[name]
      , ad.[appdomain_name]
      , clr.[load_time]
FROM sys.dm_clr_loaded_assemblies AS clr
      INNER JOIN sys.assemblies AS sa
            ON clr.assembly_id = sa.assembly_id
      INNER JOIN sys.dm_clr_appdomains AS ad
            ON clr.appdomain_address = ad.appdomain_address
 
-- SQL CLR Memory Usage
SELECT mo.[type]
      , sum(mo.pages_allocated_count * mo.page_size_in_bytes/1024) 
            AS N'Current KB'
      , sum(mo.max_pages_allocated_count * mo.page_size_in_bytes/1024) 
            AS N'Max KB'
FROM sys.dm_os_memory_objects AS mo
WHERE mo.[type] LIKE '%clr%'
GROUP BY mo.[type]
ORDER BY mo.[type]
--

-- SQL CLR Wait Statistics
SELECT ws.* 
FROM sys.dm_os_wait_stats AS ws
WHERE ws.wait_type LIKE '%clr%'
 
-- Requests that are currently in SQL CLR
SELECT session_id, request_id, start_time, status, command, database_id,
wait_type, wait_time, last_wait_type, wait_resource, cpu_time,
total_elapsed_time, nest_level, executing_managed_code
FROM sys.dm_exec_requests
WHERE executing_managed_code = 1
 
-- Query performance and time spent in SQL CLR.
SELECT 
(SELECT text FROM sys.dm_exec_sql_text(qs.sql_handle)) AS query_text, qs.*
FROM sys.dm_exec_query_stats AS qs
WHERE qs.total_clr_time > 0 
ORDER BY qs.total_clr_time desc
 
-- Obtaining CLR Execution performance counter values.
SELECT object_name, counter_name, cntr_value, cntr_type
FROM sys.dm_os_performance_counters
WHERE counter_name LIKE '%CLR%'


--3. CLR Procedure can be found in sysobjects table
select * from sys.objects where type_desc ='CLR_STORED_PROCEDURE'

--4. CLR procedures & functions can be found in Object Explorer
--Try to modify the existing function in IDE and deploy it. 
--drop function GetCLRFrameworkMajorVersion
--alter assembly SQLCLRLibrary drop file ALL

Select * from sys.assembly_modules
select * from sys.assembly_types
select * from sys.assembly_files
--alter assembly SQLCLRLibrary drop file ALL
Sys.assemblies,Sys.assembly_files,Sys.assembly_references
	--SYS.OBJECTS,SYS.ASSEMBLY_MODULES,SYS.ASSEMBLY_TYPES
	
	
--Since our database will be accessing external resources, you will need to make it trustworthy
alter database AdventureWorks set trustworthy on

--E.g. for webservice functions : 1. Tax Calclulations,Weather Info, Currency conversion

--Once deployed the tbv from VS, then

SELECT coln1 FROM dbo.ParseString('a,b,c') ORDER BY coln1 DESC

-- Refresh assembly from the file-system
ALTER ASSEMBLY myprocs FROM 'c:\temp\myprocs.dll'