﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;


public partial class StoredProcedures
{
    [Microsoft.SqlServer.Server.SqlProcedure]
    public static void GetUserWithId(int userIdInput)
    {
        // Put your code here
        bool bemailvalidated;
        string username = string.Empty;
        string emailaddress = string.Empty;
        if(!getUserInfo(userIdInput,ref username,ref emailaddress))
        {
            return;
        }

        EmailValidation objValidation = new EmailValidation();
        bemailvalidated = objValidation.ValidateEmail(emailaddress);
        SqlDataRecord objRecord = createDataRecord(userIdInput, username, emailaddress, bemailvalidated);
        SqlContext.Pipe.Send(objRecord);
    }
    static bool getUserInfo(int userId, ref string userName, ref string emailId)
    {
        bool bUserFound = false;
        using (SqlConnection objConn = new SqlConnection("Context Connection = true"))
        {
            using (SqlCommand objCmd = new SqlCommand("uspGetUserWithId"))
            {
                objCmd.Connection = objConn;
                objCmd.CommandType = CommandType.StoredProcedure;
                objCmd.Parameters.AddWithValue("@userId", userId);
                objCmd.Parameters["@userId"].Direction = ParameterDirection.Input;
                objConn.Open();
                using (SqlDataReader objReader = objCmd.ExecuteReader())
                {
                    if (objReader.Read())
                    {
                        userName = Convert.ToString(objReader["username"]);
                        emailId = Convert.ToString(objReader["emaildid"]);
                        bUserFound = true;
                    }
                }
            }
        }
        return bUserFound;
    }

    static SqlDataRecord createDataRecord(int userId, string userName, string emailaddress, bool bvalidation)
    {
        SqlMetaData[] fields = new SqlMetaData[4];
        fields[0] = new SqlMetaData("userid", SqlDbType.Int);
        fields[1] = new SqlMetaData("username", SqlDbType.NChar,50);
        fields[2] = new SqlMetaData("emaildid", SqlDbType.NChar, 50);
        fields[3] = new SqlMetaData("emailvalid", SqlDbType.Bit);
        SqlDataRecord objrecord = new SqlDataRecord(fields);
        objrecord.SetInt32(0, userId);
        objrecord.SetString(1, userName);
        objrecord.SetString(2, emailaddress);
        objrecord.SetBoolean(3, bvalidation);
        return objrecord;
    }
};
